apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ poller_name }}
  name: {{ poller_name }}
  namespace: {{ namespace }}
spec:
  replicas: 1
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ poller_name }}
  strategy:
    type: Rolling
{% else %}
    name: {{ poller_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    type: Rolling
{% endif %}
  template:
    metadata:
      labels:
        name: {{ poller_name }}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ poller_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ poller_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
        - name: BEHIND_PROXY
          value: "true"
        - name: DATABASE_URL
          valueFrom:
            secretKeyRef:
              key: database-url
              name: {{ slpg_name }}
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: HOME
          value: /srv/scalelite
        - name: LOADBALANCER_SECRET
          valueFrom:
            secretKeyRef:
              key: loadbalancer-key
              name: {{ scalelite_name }}
        - name: NGINX_SSL
          value: "false"
        - name: RECORDING_IMPORT_POLL
          value: "false"
        - name: REDIS_URL
          value: redis://{{ cache_name }}-proxy:6379
        - name: SECRET_KEY_BASE
          valueFrom:
            secretKeyRef:
              key: secret-key
              name: {{ scalelite_name }}
        - name: TZ
          value: {{ timezone }}
        - name: URL_HOST
          value: scalelite.{{ root_domain }}
{% if do_triggers == False or (opsimages | json_query("[?name=='scalelite_poller'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='scalelite_poller'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        name: poller
        resources:
          limits:
            cpu: "{{ scalelite_poller_cpu_limit }}"
            memory: "{{ scalelite_poller_memory_limit }}"
          requests:
            cpu: "{{ scalelite_poller_cpu_request }}"
            memory: "{{ scalelite_poller_memory_request }}"
        volumeMounts:
        - mountPath: /srv/scalelite/tmp
          name: temp
          subPath: sctemp
        - mountPath: /usr/local/share/ca-certificates
          name: pkiconf
        - mountPath: /var/bigbluebutton
          name: temp
          subPath: rctemp
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-application
{% endif %}
{% if k8s_flavor == 'kubernetes' %}
      securityContext:
        runAsUser: {{ k8s_unprivileged_userid }}
{% else %}
      securityContext: {}
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ poller_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
{% if (k8s_flavor != 'openshift' and tls_provider == 'internalca') or (bigbluebutton_ca_bundle | default([])) | length > 0 %}
      - name: pkiconf
        projected:
          sources:
{% if k8s_flavor != 'openshift' and tls_provider == 'internalca' %}
          - secret:
              items:
              - key: ca.crt
                path: ca.crt
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% if (bigbluebutton_ca_bundle | default([])) | length > 0 %}
{% for cert in bigbluebutton_ca_bundle %}
          - configMap:
              items:
              - key: bigbluebutton-chain{{ loop.index0 }}.crt
                path: bigbluebutton-chain{{ loop.index0 }}.crt
              name: {{ scalelite_name }}
{% endfor %}
{% endif %}
{% else %}
      - emptyDir: {}
        name: pkiconf
{% endif %}
      - emptyDir: {}
        name: temp
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='scalelite_poller'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - poller
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='scalelite_poller'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
  - type: ConfigChange
{% endif %}
